jjb: lttng-modules: Fix kernel build failures
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
51c9c62d 1#!/bin/bash
f3d8604b 2#
51c9c62d 3# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
51c9c62d
MJ
18set -exu
19
39961776 20# Parameters
2456f978 21arch=${arch:-amd64}
39961776
MJ
22cross_arch=${cross_arch:-}
23ktag=${ktag:-}
5a196804
MJ
24kgitrepo=${kgitrepo:-}
25mversion=${mversion:-}
26mgitrepo=${mgitrepo:-}
39961776
MJ
27
28
339db64d
MJ
29## FUNCTIONS ##
30
f3d8604b
MJ
31# Kernel version compare functions
32verlte() {
51fa2ab3 33 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
34}
35
36verlt() {
28b10e79 37 # shellcheck disable=SC2015
51fa2ab3 38 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
39}
40
41vergte() {
51fa2ab3 42 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
43}
44
45vergt() {
28b10e79 46 # shellcheck disable=SC2015
51fa2ab3 47 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
48}
49
339db64d 50
5a196804
MJ
51git_clone_modules_sources() {
52 mkdir -p "$MODULES_GIT_DIR"
28b10e79
MJ
53
54 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
55 # as a branch name.
56 if [ "${mversion:0:5}" = "refs/" ]; then
57 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
58 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
59 else
60 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
61 fi
5a196804
MJ
62}
63
64# Checkout a shallow kernel tree of the specified tag
65git_clone_linux_sources() {
66 mkdir -p "$LINUX_GIT_DIR"
67 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
68}
7e02032c 69
7e02032c 70
5a196804
MJ
71# Export the kernel sources from the git repo
72git_export_linux_sources() {
73 cd "$LINUX_GIT_DIR"
74 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
75}
76
77
78# Upload the tar archive to the object store
79upload_archive_obj() {
80 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
81 rm -f "$WORKSPACE/$obj_name"
82}
83
84
85extract_archive_obj() {
86 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
87 rm -f "$WORKSPACE/$obj_name"
88}
89
90
91tar_archive_obj() {
92 cd "$LINUX_OBJ_DIR"
93 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
94 cd -
95}
96
97# Find the most recent GCC version supported by the kernel sources
98select_compiler() {
99 local selected_cc
100
101 cd "$LINUX_SRCOBJ_DIR"
102
103 kversion=$(make -s kernelversion)
104
105 set +e
106
2456f978 107 for cc in gcc-8 gcc-5 gcc-4.8; do
5a196804
MJ
108 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
109 selected_cc="$cc"
110 break
111 fi
112 done
113
114 set -e
115
116 if [ "x$selected_cc" = "x" ]; then
117 echo "Found no suitable compiler."
118 exit 1
119 fi
120
1d5a0a3c
MJ
121 # Force gcc-4.8 for kernels before 3.18
122 if { verlt "$kversion" "3.18"; }; then
23db2292 123 selected_cc=gcc-4.8
7e02032c
MJ
124 fi
125
425e4992
MJ
126 if [ "$selected_cc" != "gcc-4.8" ]; then
127 # Older kernel Makefiles do not expect the compiler to default to PIE
128 KAFLAGS="-fno-pie"
c45b04df 129 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
130 KCPPFLAGS="-fno-pie"
131 export KAFLAGS KCFLAGS KCPPFLAGS
132 fi
133
5a196804 134 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 135 export HOSTCC="${selected_cc}"
5a196804
MJ
136
137 cd -
138}
139
140
141build_linux_kernel() {
142 cd "$LINUX_SRCOBJ_DIR"
143
144 kversion=$(make -s kernelversion)
145
7e02032c 146 # Generate kernel configuration
a1ae361e 147 case "$ktag" in
7e02032c 148 Ubuntu*)
39961776 149 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 150 if vergte "${kversion}" "4.10"; then
39961776
MJ
151 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
152 exit 0
153 fi
154 fi
af101606
MJ
155
156 # Disable riscv64 config generation, we don't have a toolchain on bionic
157 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
158
073dc82c
MJ
159 # Hack for kernel Ubuntu-hwe-5.8
160 if [ ! -f "debian/compat" ]; then
161 echo "10" > "debian/compat"
162 fi
163
a46abb0a
MJ
164 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
165 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 166 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 167 ;;
c45b04df 168
7e02032c 169 *)
16844a6d
MJ
170 # Force 32bit build on i386, default is 64bit
171 if [ "$arch" = "i386" ]; then
5a196804
MJ
172 export ARCH="i386"
173 fi
174
175 # allyesconfig is mostly broken for kernels of the 2.6 series
176 if verlt "$kversion" "3.0"; then
177 vanilla_config="defconfig"
7a76a4d0
MJ
178 fi
179
5a196804 180 make "${vanilla_config}"
7e02032c
MJ
181 ;;
182 esac
183
53b51a15 184 # oldnoconfig was renamed in 4.19
5a196804 185 if vergte "$kversion" "4.19"; then
53b51a15 186 update_conf_target="olddefconfig"
5a196804 187 else
53b51a15 188 update_conf_target="oldnoconfig"
5a196804
MJ
189 fi
190
191 # Fix 'defined(@array)' was removed from recent perl
192 if [ -f "kernel/timeconst.pl" ]; then
193 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
194 fi
195
196 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 197 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
198 if [ -f "arch/x86/kvm/svm.c" ]; then
199 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
200 fi
201
202 if [ -f "arch/x86/kvm/vmx.c" ]; then
203 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
204 fi
205 fi
206
53b51a15
MJ
207 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
208 # Convert them to 'cmpw' which was previously done silently
209 if verlt "$kversion" "4.9"; then
210 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
211 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
212 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
213 fi
214
5a196804
MJ
215 # Fix a typo in v2.6.36.x
216 if [ -f "arch/x86/kernel/entry_64.S" ]; then
217 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
218 fi
219
53b51a15
MJ
220 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
221 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
222 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
223 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
224 fi
225
5a196804
MJ
226 # Fix kernel < 3.0 with gcc >= 4.7
227 if verlt "$kversion" "3.0"; then
228 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
229 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
230 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
231 echo "header-y += linkage.h" >> include/linux/Kbuild
232 fi
233
7e02032c 234 # GCC 4.8
53b51a15
MJ
235 if [ "$HOSTCC" == "gcc-4.8" ]; then
236 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
237 fi
7e02032c
MJ
238
239 # Don't try to sign modules
53b51a15 240 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 241
9ef18fa2 242 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 243 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
244
245 # Cause problems with inline assembly on i386
53b51a15 246 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 247
1d5a0a3c 248 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
249 scripts/config --disable CONFIG_SAMPLES
250 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
251
252 # Disable kcov
53b51a15 253 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
254
255 # Broken on some RT kernels
53b51a15 256 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 257
1e300ea9 258 # Broken drivers
53b51a15
MJ
259 scripts/config --disable CONFIG_RAPIDIO_TSI721
260 scripts/config --disable CONFIG_SGI_XP
261 scripts/config --disable CONFIG_MFD_WM8994
262 scripts/config --disable CONFIG_DRM_RADEON
263 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 264
5a196804
MJ
265 # IGBVF won't build with recent gcc on 2.6.38.x
266 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 267 scripts/config --disable CONFIG_IGBVF
5a196804 268 fi
9ef18fa2 269
51fa2ab3 270 # Set required options
53b51a15
MJ
271 scripts/config --enable CONFIG_TRACEPOINTS
272 scripts/config --enable CONFIG_KALLSYMS
273 scripts/config --enable CONFIG_HIGH_RES_TIMERS
274 scripts/config --enable CONFIG_KPROBES
275 scripts/config --enable CONFIG_FTRACE
276 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
277 scripts/config --enable CONFIG_KALLSYMS_ALL
278 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
279 scripts/config --enable CONFIG_PERF_EVENTS
280 scripts/config --enable CONFIG_EVENT_TRACING
281 scripts/config --enable CONFIG_KRETPROBES
7e02032c 282
7a76a4d0 283 # Debug
5a196804
MJ
284 #cat .config
285
286 make "$update_conf_target" CC="$CC"
287 make -j"$NPROC" CC="$CC"
288
c45b04df 289 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
290
291 # Save the kernel and modules
292 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15 293 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
f4c112e8 294 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
295 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
296 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
297 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
298}
299
300
301extract_distro_headers() {
302
303 # Enter linux source dir
304 cd "${LINUX_SRCOBJ_DIR}"
305
306
307 # For RT kernels, copy version file
308 if [ -s localversion-rt ]; then
309 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
310 fi
311
312 # Copy all Makefile related stuff
313 find . -path './include/*' -prune \
314 -o -path './scripts/*' -prune -o -type f \
315 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
316 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
317 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
318
319 # Copy base scripts and include dirs
320 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 321
5a196804
MJ
322 # Copy arch includes
323 (find arch -name include -type d -print0 | \
324 xargs -0 -n1 -i: find : -type f) | \
325 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
326
327 # Copy arch scripts
328 (find arch -name scripts -type d -print0 | \
329 xargs -0 -n1 -i: find : -type f) | \
330 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
331
332 # Cleanup scripts
333 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
334 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
335
04873cc3 336 # On powerpc 32bits this object is required to link modules
5a196804 337 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
338 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
339 :
340 else
04873cc3
MJ
341 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
342 fi
5a196804
MJ
343 fi
344
345 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
346 if [ "${karch}" = "arm64" ]; then
347 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
348 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
349 fi
350 fi
351
352 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
353 if [ -f tools/objtool/objtool ]; then
354 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
355 fi
356
357 if [ -f "arch/x86/kernel/macros.s" ]; then
358 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
359 fi
360
361 # Copy modules related stuff, if available
362 if [ -s Module.symvers ]; then
363 cp Module.symvers "${LINUX_HDROBJ_DIR}"
364 fi
365
366 if [ -s System.map ]; then
367 cp System.map "${LINUX_HDROBJ_DIR}"
368 fi
369
370 if [ -s Module.markers ]; then
371 cp Module.markers "${LINUX_HDROBJ_DIR}"
372 fi
373
374 # Copy config file
375 cp .config "${LINUX_HDROBJ_DIR}"
376
377 # Make sure the Makefile and version.h have a matching timestamp so that
378 # external modules can be built
379 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
380 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
381 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
382 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
383 else
384 echo "Missing version.h"
385 exit 1
386 fi
387 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
388
389 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
390 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
391
392 # Finally clean the object files from the full source tree
393 make clean
394
395 # And regen the modules support files
396 make modules_prepare CC="$CC"
51fa2ab3 397
04873cc3 398 # On powerpc 32bits this object is required to link modules
d815b018 399 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
400 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
401 :
402 else
04873cc3
MJ
403 make arch/powerpc/lib/crtsavres.o CC="$CC"
404 fi
d815b018
MJ
405 fi
406
7a76a4d0 407 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 408 if [ "${karch}" = "arm64" ]; then
c236528e 409 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 410 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
411 fi
412 fi
413
7e02032c 414 # Version specific tasks
a1ae361e 415 case "$ktag" in
7e02032c
MJ
416 Ubuntu*)
417 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 418 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
419 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
420 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
421 ;;
422 esac
7e02032c
MJ
423}
424
425
339db64d
MJ
426build_modules() {
427
5a196804
MJ
428 local kdir="$1"
429 local outdir="$2"
430 local kversion
431
432 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 433
2456f978
MJ
434 # Try to catch some compatibility problems by turning some
435 # warnings into errors.
436 export KCFLAGS="$KCFLAGS -Wall -Werror"
437
339db64d 438 # Enter lttng-modules source dir
5a196804 439 cd "${MODULES_GIT_DIR}"
339db64d
MJ
440
441 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
442 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
443 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
444 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
445
446 set +e
447
448 # Build modules
51fa2ab3 449 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 450 ret=$?
339db64d 451
5a196804
MJ
452 set -e
453
339db64d 454 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 455 if [ "$ret" -eq 0 ]; then
e9b44189 456 echo "This build should have failed."
339db64d
MJ
457 exit 1
458 fi
459
460 # We have to publish at least one file or the build will fail
5a196804 461 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 462
5a196804 463 KERNELDIR="${kdir}" make clean
7e02032c 464
339db64d
MJ
465 else # Regular build
466
467 # Build modules against full kernel sources
51fa2ab3 468 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
469
470 # Install modules to build dir
5a196804 471 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
472
473 # Clean build dir
5a196804 474 KERNELDIR="${kdir}" make clean
339db64d
MJ
475 fi
476}
477
478
479## MAIN ##
480
f3d8604b
MJ
481# Use all CPU cores
482NPROC=$(nproc)
483
5a196804
MJ
484MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
485LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 486
5a196804
MJ
487LINUX_OBJ_DIR="${WORKSPACE}/linux"
488LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
489LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
490LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 491
5a196804
MJ
492MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
493MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 494
5a196804
MJ
495LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
496
497OBJ_STORE_URL="s3://jenkins"
498
499cd "$WORKSPACE"
500
501# Create build directories
502mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
503
504git_clone_modules_sources
339db64d 505
7e02032c 506# Setup cross compile env if available
39961776 507if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
508
509 case "$cross_arch" in
510 "armhf")
511 karch="arm"
512 cross_compile="arm-linux-gnueabihf-"
53b51a15 513 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
514 ubuntu_config="armhf-config.flavour.generic"
515 ;;
516
517 "arm64")
518 karch="arm64"
519 cross_compile="aarch64-linux-gnu-"
53b51a15 520 vanilla_config="defconfig"
7e02032c
MJ
521 ubuntu_config="arm64-config.flavour.generic"
522 ;;
523
524 "powerpc")
525 karch="powerpc"
526 cross_compile="powerpc-linux-gnu-"
e9b44189 527 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
528 ubuntu_config="powerpc-config.flavour.powerpc-smp"
529 ;;
530
531 "ppc64el")
532 karch="powerpc"
533 cross_compile="powerpc64le-linux-gnu-"
e9b44189 534 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
535 ubuntu_config="ppc64el-config.flavour.generic"
536 ;;
537
538 *)
51fa2ab3 539 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
540 exit 1
541 ;;
542 esac
339db64d 543
7e02032c
MJ
544 # Export variables used by Kbuild for cross compilation
545 export ARCH="${karch}"
546 export CROSS_COMPILE="${cross_compile}"
339db64d 547
7e02032c 548# Set arch specific values if we are not cross compiling
39961776 549elif [ "x${arch}" != "x" ]; then
e9b44189 550
7e02032c 551 case "$arch" in
16844a6d 552 "i386")
7e02032c 553 karch="x86"
e9b44189 554 vanilla_config="allyesconfig"
7e02032c
MJ
555 ubuntu_config="i386-config.flavour.generic"
556 ;;
557
16844a6d 558 "amd64")
7e02032c 559 karch="x86"
e9b44189 560 vanilla_config="allyesconfig"
7e02032c
MJ
561 ubuntu_config="amd64-config.flavour.generic"
562 ;;
563
564 "armhf")
565 karch="arm"
e9b44189 566 vanilla_config="allyesconfig"
7e02032c
MJ
567 ubuntu_config="armhf-config.flavour.generic"
568 ;;
569
570 "arm64")
571 karch="arm64"
e9b44189 572 vanilla_config="allyesconfig"
7e02032c
MJ
573 ubuntu_config="arm64-config.flavour.generic"
574 ;;
575
576 "powerpc")
577 karch="powerpc"
e9b44189 578 vanilla_config="allyesconfig"
7e02032c
MJ
579 ubuntu_config="powerpc-config.flavour.powerpc-smp"
580 ;;
581
582 "ppc64el")
583 karch="powerpc"
e9b44189 584 vanilla_config="allyesconfig"
7e02032c
MJ
585 ubuntu_config="ppc64el-config.flavour.generic"
586 ;;
587
588 *)
589 echo "Unsupported arch $arch"
590 exit 1
591 ;;
592 esac
593else
04873cc3 594 echo "No arch or cross_arch specified"
7e02032c
MJ
595 exit 1
596fi
339db64d 597
339db64d 598
b214d997 599
5a196804
MJ
600# First get the kernel build from the object store, or build it, if it's
601# not available.
339db64d 602
5a196804
MJ
603echo "# Setup endpoint
604host_base = obj.internal.efficios.com
605host_bucket = obj.internal.efficios.com
606bucket_location = us-east-1
607use_https = True
7e02032c 608
5a196804
MJ
609# Setup access keys
610access_key = jenkins
611secret_key = echo123456
339db64d 612
5a196804
MJ
613# Enable S3 v4 signature APIs
614signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 615
c45b04df 616url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 617obj_name="linux.tar.bz2"
87445931
MJ
618
619if [ "x${cross_arch}" = "x" ]; then
620 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/native"
621else
622 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/${cross_arch}"
623fi
624
5a196804 625obj_url="$obj_url_prefix/$obj_name"
339db64d 626
5a196804
MJ
627set +e
628s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
629ret=$?
630set -e
339db64d 631
5a196804
MJ
632case "$ret" in
633 "0")
634 extract_archive_obj
635 ;;
a1ae361e 636
5a196804
MJ
637 "12")
638 echo "File not found"
339db64d 639
5a196804
MJ
640 # Build all the things and upload
641 # then finish the module build...
339db64d 642
5a196804
MJ
643 git_clone_linux_sources
644 git_export_linux_sources
339db64d 645
5a196804 646 select_compiler
a1ae361e 647
5a196804
MJ
648 ## PREPARE FULL LINUX SOURCE TREE
649 build_linux_kernel
d138fc44 650
5a196804
MJ
651 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
652 extract_distro_headers
339db64d 653
5a196804 654 tar_archive_obj
339db64d 655
5a196804 656 upload_archive_obj
339db64d 657
5a196804 658 ;;
339db64d 659
5a196804
MJ
660 *)
661 echo "Unknown error? Abort"
662 exit 1
663 ;;
664esac
339db64d 665
5a196804 666select_compiler
f3d8604b 667
7e02032c 668## BUILD modules
5a196804
MJ
669# Either we downloaded a pre-build kernel or we built it and uploaded
670# the archive for future builds.
671
672cd "$WORKSPACE"
f3d8604b 673
339db64d 674# Build modules against full kernel sources
5a196804 675build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 676
339db64d 677# Build modules against kernel headers
5a196804 678build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 679
5a196804
MJ
680# Make sure some modules were actually built
681tree "${MODULES_OUTPUT_KSRC_DIR}"
682if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
683 echo "No modules built!"
684 exit 1
685fi
686
5a196804
MJ
687tree "${MODULES_OUTPUT_KHDR_DIR}"
688if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
689 echo "No modules built!"
690 exit 1
691fi
b214d997 692
f3d8604b 693# EOF
This page took 0.059075 seconds and 4 git commands to generate.